package de.ugoe.cs.autoquest.tasktrees.alignment.algorithms;

import java.util.ArrayList;
import java.util.LinkedList;



public class Match {
	private ArrayList<NumberSequence> matchseqs;

	private LinkedList<MatchOccurence> occurences;

	public Match() {
		matchseqs = new ArrayList<NumberSequence>(2);
		occurences = new LinkedList<MatchOccurence>();
		matchseqs.add(null);
		matchseqs.add(null);
	}

	public NumberSequence getFirstSequence() {
		return matchseqs.get(0);
	}

	public NumberSequence getSecondSequence() {
		return matchseqs.get(1);
	}

	public void setFirstSequence(NumberSequence seq) {
		matchseqs.set(0, seq);
	}

	public void setSecondSequence(NumberSequence seq) {
		matchseqs.set(1, seq);
	}

	public void addOccurence(MatchOccurence occurence) {
		occurences.add(occurence);
	}

	public int occurenceCount() {
		return occurences.size();
	}
	
	public int size() {
		//Both sequences should be equally long
		return matchseqs.get(0).size();
	}

	public boolean equals(Match m) {
		if ((m.getFirstSequence().equals(this.getFirstSequence()) || m
				.getFirstSequence().equals(this.getSecondSequence()))
				&& (m.getSecondSequence().equals(this.getFirstSequence()) || m
						.getSecondSequence().equals(this.getSecondSequence()))) {
			return true;
		}
		return false;
	}

	public LinkedList<MatchOccurence> getOccurences() {
		return occurences;
	}

	public void setOccurences(LinkedList<MatchOccurence> occurences) {
		this.occurences = occurences;
	}

	
	public void addOccurencesOf(Match m) {
		occurences.addAll(m.getOccurences());
	}
	
	
   

}
